/*!
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2014 - 2020
 * @version 1.3.6
 *
 * Date formatter utility library that allows formatting date/time variables or Date objects using PHP DateTime format.
 * This library is a standalone javascript library and does not depend on other libraries or plugins like jQuery. The
 * library also adds support for Universal Module Definition (UMD).
 * 
 * @see http://php.net/manual/en/function.date.php
 *
 * For more JQuery plugins visit http://plugins.krajee.com
 * For more Yii related demos visit http://demos.krajee.com
 */(function(b,a){typeof define=='function'&&define.amd?define([],a):typeof module=='object'&&module.exports?module.exports=a():b.DateFormatter=a()})(typeof self!='undefined'?self:this,function(){var b,a;return a={DAY:1e3*60*60*24,HOUR:3600,defaults:{dateSettings:{days:['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'],daysShort:['Sun','Mon','Tue','Wed','Thu','Fri','Sat'],months:['January','February','March','April','May','June','July','August','September','October','November','December'],monthsShort:['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'],meridiem:['AM','PM'],ordinal:function(a){var b=a%10,c={1:'st',2:'nd',3:'rd'};return Math.floor(a%100/10)===1||!c[b]?'th':c[b]}},separators:/[ \-+\/.:@]/g,validParts:/[dDjlNSwzWFmMntLoYyaABgGhHisueTIOPZcrU]/g,intParts:/[djwNzmnyYhHgGis]/g,tzParts:/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,tzClip:/[^-+\dA-Z]/g},getInt:function(b,a){return parseInt(b,a||10)},compare:function(a,b){return typeof a=='string'&&typeof b=='string'&&a.toLowerCase()===b.toLowerCase()},lpad:function(e,d,b){var c=e.toString();return b=b||'0',c.length<d?a.lpad(b+c,d):c},merge:function(d){var e,b,c;d=d||{};for(e=1;e<arguments.length;e++){if(b=arguments[e],!b)continue;for(c in b)b.hasOwnProperty(c)&&(typeof b[c]=='object'?a.merge(d[c],b[c]):d[c]=b[c])}return d},getIndex:function(c,b){for(var a=0;a<b.length;a++)if(b[a].toLowerCase()===c.toLowerCase())return a;return-1}},b=function(d){var b=this,c=a.merge(a.defaults,d);b.dateSettings=c.dateSettings,b.separators=c.separators,b.validParts=c.validParts,b.intParts=c.intParts,b.tzParts=c.tzParts,b.tzClip=c.tzClip},b.prototype={constructor:b,getMonth:function(c){var d=this,b;return b=a.getIndex(c,d.dateSettings.monthsShort)+1,b===0&&(b=a.getIndex(c,d.dateSettings.months)+1),b},parseDate:function(f,r){var l=this,e,k,d,j=!1,g=!1,h,b,p=l.dateSettings,m,n,i,q,o,c={date:null,year:null,month:null,day:null,hour:0,min:0,sec:0},s,t,u;if(!f)return null;if(f instanceof Date)return f;if(r==='U')return d=a.getInt(f),d?new Date(d*1e3):f;switch(typeof f){case'number':return new Date(f);case'string':break;default:return null}if(e=r.match(l.validParts),!e||e.length===0)throw new Error('Invalid date format definition.');for(d=e.length-1;d>=0;d--)e[d]==='S'&&e.splice(d,1);k=f.replace(l.separators,'\0').split('\0');for(d=0;d<k.length;d++)switch(h=k[d],b=a.getInt(h),e[d]){case'y':case'Y':if(b)q=h.length,c.year=q===2?a.getInt((b<70?'20':'19')+h):b;else return null;j=!0;break;case'm':case'n':case'M':case'F':if(isNaN(b))if(m=l.getMonth(h),m>0)c.month=m;else return null;else if(b>=1&&b<=12)c.month=b;else return null;j=!0;break;case'd':case'j':if(b>=1&&b<=31)c.day=b;else return null;j=!0;break;case'g':case'h':if(n=e.indexOf('a')>-1?e.indexOf('a'):e.indexOf('A')>-1?e.indexOf('A'):-1,o=k[n],n!==-1)i=a.compare(o,p.meridiem[0])?0:a.compare(o,p.meridiem[1])?12:-1,b>=1&&b<=12&&i!==-1?c.hour=b%12===0?i:b+i:b>=0&&b<=23&&(c.hour=b);else if(b>=0&&b<=23)c.hour=b;else return null;g=!0;break;case'G':case'H':if(b>=0&&b<=23)c.hour=b;else return null;g=!0;break;case'i':if(b>=0&&b<=59)c.min=b;else return null;g=!0;break;case's':if(b>=0&&b<=59)c.sec=b;else return null;g=!0;break}if(j===!0)s=c.year||0,t=c.month?c.month-1:0,u=c.day||1,c.date=new Date(s,t,u,c.hour,c.min,c.sec,0);else{if(g!==!0)return null;c.date=new Date(0,0,0,c.hour,c.min,c.sec,0)}return c.date},guessDate:function(i,o){if(typeof i!='string')return i;var m=this,k=i.replace(m.separators,'\0').split('\0'),n=/^[djmn]/g,g,h=o.match(m.validParts),b=new Date,j=0,f,d,l,e,c;if(!n.test(h[0]))return i;for(d=0;d<k.length;d++){if(j=2,e=k[d],c=a.getInt(e.substr(0,2)),isNaN(c))return null;switch(d){case 0:h[0]==='m'||h[0]==='n'?b.setMonth(c-1):b.setDate(c);break;case 1:h[0]==='m'||h[0]==='n'?b.setDate(c):b.setMonth(c-1);break;case 2:if(f=b.getFullYear(),g=e.length,j=g<4?g:4,f=a.getInt(g<4?f.toString().substr(0,4-g)+e:e.substr(0,4)),!f)return null;b.setFullYear(f);break;case 3:b.setHours(c);break;case 4:b.setMinutes(c);break;case 5:b.setSeconds(c);break}l=e.substr(j),l.length>0&&k.splice(d+1,0,l)}return b},parseFormat:function(h,c){var f=this,d=f.dateSettings,b,g=/\\?(.?)/gi,e=function(a,c){return b[a]?b[a]():c};return b={d:function(){return a.lpad(b.j(),2)},D:function(){return d.daysShort[b.w()]},j:function(){return c.getDate()},l:function(){return d.days[b.w()]},N:function(){return b.w()||7},w:function(){return c.getDay()},z:function(){var c=new Date(b.Y(),b.n()-1,b.j()),d=new Date(b.Y(),0,1);return Math.round((c-d)/a.DAY)},W:function(){var c=new Date(b.Y(),b.n()-1,b.j()-b.N()+3),d=new Date(c.getFullYear(),0,4);return a.lpad(1+Math.round((c-d)/a.DAY/7),2)},F:function(){return d.months[c.getMonth()]},m:function(){return a.lpad(b.n(),2)},M:function(){return d.monthsShort[c.getMonth()]},n:function(){return c.getMonth()+1},t:function(){return new Date(b.Y(),b.n(),0).getDate()},L:function(){var a=b.Y();return a%4===0&&a%100!==0||a%400===0?1:0},o:function(){var a=b.n(),c=b.W(),d=b.Y();return d+(a===12&&c<9?1:a===1&&c>9?-1:0)},Y:function(){return c.getFullYear()},y:function(){return b.Y().toString().slice(-2)},a:function(){return b.A().toLowerCase()},A:function(){var a=b.G()<12?0:1;return d.meridiem[a]},B:function(){var b=c.getUTCHours()*a.HOUR,d=c.getUTCMinutes()*60,e=c.getUTCSeconds();return a.lpad(Math.floor((b+d+e+a.HOUR)/86.4)%1e3,3)},g:function(){return b.G()%12||12},G:function(){return c.getHours()},h:function(){return a.lpad(b.g(),2)},H:function(){return a.lpad(b.G(),2)},i:function(){return a.lpad(c.getMinutes(),2)},s:function(){return a.lpad(c.getSeconds(),2)},u:function(){return a.lpad(c.getMilliseconds()*1e3,6)},e:function(){var a=/\((.*)\)/.exec(String(c))[1];return a||'Coordinated Universal Time'},I:function(){var a=new Date(b.Y(),0),c=Date.UTC(b.Y(),0),d=new Date(b.Y(),6),e=Date.UTC(b.Y(),6);return a-c!==d-e?1:0},O:function(){var b=c.getTimezoneOffset(),d=Math.abs(b);return(b>0?'-':'+')+a.lpad(Math.floor(d/60)*100+d%60,4)},P:function(){var a=b.O();return a.substr(0,3)+':'+a.substr(3,2)},T:function(){var a=(String(c).match(f.tzParts)||['']).pop().replace(f.tzClip,'');return a||'UTC'},Z:function(){return-c.getTimezoneOffset()*60},c:function(){return'Y-m-d\\TH:i:sP'.replace(g,e)},r:function(){return'D, d M Y H:i:s O'.replace(g,e)},U:function(){return c.getTime()/1e3||0}},e(h,h)},formatDate:function(c,e){var f=this,b,j,h,g,d,i='',k='\\';if(typeof c=='string')if(c=f.parseDate(c,e),!c)return null;if(c instanceof Date){h=e.length;for(b=0;b<h;b++){if(d=e.charAt(b),d==='S'||d===k)continue;if(b>0&&e.charAt(b-1)===k){i+=d;continue}g=f.parseFormat(d,c),b!==h-1&&f.intParts.test(d)&&e.charAt(b+1)==='S'&&(j=a.getInt(g)||0,g+=f.dateSettings.ordinal(j)),i+=g}return i}return''}},b});var datetimepickerFactory=function(a){'use strict';var c={i18n:{ar:{months:["كانون الثاني","شباط","آذار","نيسان","مايو","حزيران","تموز","آب","أيلول","تشرين الأول","تشرين الثاني","كانون الأول"],dayOfWeekShort:["ن","ث","ع","خ","ج","س","ح"],dayOfWeek:["الأحد","الاثنين","الثلاثاء","الأربعاء","الخميس","الجمعة","السبت","الأحد"]},ro:{months:["Ianuarie","Februarie","Martie","Aprilie","Mai","Iunie","Iulie","August","Septembrie","Octombrie","Noiembrie","Decembrie"],dayOfWeekShort:["Du","Lu","Ma","Mi","Jo","Vi","Sâ"],dayOfWeek:["Duminică","Luni","Marţi","Miercuri","Joi","Vineri","Sâmbătă"]},id:{months:["Januari","Februari","Maret","April","Mei","Juni","Juli","Agustus","September","Oktober","November","Desember"],dayOfWeekShort:["Min","Sen","Sel","Rab","Kam","Jum","Sab"],dayOfWeek:["Minggu","Senin","Selasa","Rabu","Kamis","Jumat","Sabtu"]},is:{months:["Janúar","Febrúar","Mars","Apríl","Maí","Júní","Júlí","Ágúst","September","Október","Nóvember","Desember"],dayOfWeekShort:["Sun","Mán","Þrið","Mið","Fim","Fös","Lau"],dayOfWeek:["Sunnudagur","Mánudagur","Þriðjudagur","Miðvikudagur","Fimmtudagur","Föstudagur","Laugardagur"]},bg:{months:["Януари","Февруари","Март","Април","Май","Юни","Юли","Август","Септември","Октомври","Ноември","Декември"],dayOfWeekShort:["Нд","Пн","Вт","Ср","Чт","Пт","Сб"],dayOfWeek:["Неделя","Понеделник","Вторник","Сряда","Четвъртък","Петък","Събота"]},fa:{months:['فروردین','اردیبهشت','خرداد','تیر','مرداد','شهریور','مهر','آبان','آذر','دی','بهمن','اسفند'],dayOfWeekShort:['یکشنبه','دوشنبه','سه شنبه','چهارشنبه','پنجشنبه','جمعه','شنبه'],dayOfWeek:["یک‌شنبه","دوشنبه","سه‌شنبه","چهارشنبه","پنج‌شنبه","جمعه","شنبه","یک‌شنبه"]},ru:{months:['Январь','Февраль','Март','Апрель','Май','Июнь','Июль','Август','Сентябрь','Октябрь','Ноябрь','Декабрь'],dayOfWeekShort:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],dayOfWeek:["Воскресенье","Понедельник","Вторник","Среда","Четверг","Пятница","Суббота"]},uk:{months:['Січень','Лютий','Березень','Квітень','Травень','Червень','Липень','Серпень','Вересень','Жовтень','Листопад','Грудень'],dayOfWeekShort:["Ндл","Пнд","Втр","Срд","Чтв","Птн","Сбт"],dayOfWeek:["Неділя","Понеділок","Вівторок","Середа","Четвер","П'ятниця","Субота"]},en:{months:["January","February","March","April","May","June","July","August","September","October","November","December"],dayOfWeekShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dayOfWeek:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},el:{months:["Ιανουάριος","Φεβρουάριος","Μάρτιος","Απρίλιος","Μάιος","Ιούνιος","Ιούλιος","Αύγουστος","Σεπτέμβριος","Οκτώβριος","Νοέμβριος","Δεκέμβριος"],dayOfWeekShort:["Κυρ","Δευ","Τρι","Τετ","Πεμ","Παρ","Σαβ"],dayOfWeek:["Κυριακή","Δευτέρα","Τρίτη","Τετάρτη","Πέμπτη","Παρασκευή","Σάββατο"]},de:{months:['Januar','Februar','März','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember'],dayOfWeekShort:["So","Mo","Di","Mi","Do","Fr","Sa"],dayOfWeek:["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"]},nl:{months:["januari","februari","maart","april","mei","juni","juli","augustus","september","oktober","november","december"],dayOfWeekShort:["zo","ma","di","wo","do","vr","za"],dayOfWeek:["zondag","maandag","dinsdag","woensdag","donderdag","vrijdag","zaterdag"]},tr:{months:["Ocak","Şubat","Mart","Nisan","Mayıs","Haziran","Temmuz","Ağustos","Eylül","Ekim","Kasım","Aralık"],dayOfWeekShort:["Paz","Pts","Sal","Çar","Per","Cum","Cts"],dayOfWeek:["Pazar","Pazartesi","Salı","Çarşamba","Perşembe","Cuma","Cumartesi"]},fr:{months:["Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre"],dayOfWeekShort:["Dim","Lun","Mar","Mer","Jeu","Ven","Sam"],dayOfWeek:["dimanche","lundi","mardi","mercredi","jeudi","vendredi","samedi"]},es:{months:["Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre"],dayOfWeekShort:["Dom","Lun","Mar","Mié","Jue","Vie","Sáb"],dayOfWeek:["Domingo","Lunes","Martes","Miércoles","Jueves","Viernes","Sábado"]},th:{months:['มกราคม','กุมภาพันธ์','มีนาคม','เมษายน','พฤษภาคม','มิถุนายน','กรกฎาคม','สิงหาคม','กันยายน','ตุลาคม','พฤศจิกายน','ธันวาคม'],dayOfWeekShort:['อา.','จ.','อ.','พ.','พฤ.','ศ.','ส.'],dayOfWeek:["อาทิตย์","จันทร์","อังคาร","พุธ","พฤหัส","ศุกร์","เสาร์","อาทิตย์"]},pl:{months:["styczeń","luty","marzec","kwiecień","maj","czerwiec","lipiec","sierpień","wrzesień","październik","listopad","grudzień"],dayOfWeekShort:["nd","pn","wt","śr","cz","pt","sb"],dayOfWeek:["niedziela","poniedziałek","wtorek","środa","czwartek","piątek","sobota"]},pt:{months:["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],dayOfWeekShort:["Dom","Seg","Ter","Qua","Qui","Sex","Sab"],dayOfWeek:["Domingo","Segunda","Terça","Quarta","Quinta","Sexta","Sábado"]},ch:{months:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],dayOfWeekShort:["日","一","二","三","四","五","六"]},se:{months:["Januari","Februari","Mars","April","Maj","Juni","Juli","Augusti","September","Oktober","November","December"],dayOfWeekShort:["Sön","Mån","Tis","Ons","Tor","Fre","Lör"]},km:{months:["មករា​","កុម្ភៈ","មិនា​","មេសា​","ឧសភា​","មិថុនា​","កក្កដា​","សីហា​","កញ្ញា​","តុលា​","វិច្ឆិកា","ធ្នូ​"],dayOfWeekShort:["អាទិ​","ច័ន្ទ​","អង្គារ​","ពុធ​","ព្រហ​​","សុក្រ​","សៅរ៍"],dayOfWeek:["អាទិត្យ​","ច័ន្ទ​","អង្គារ​","ពុធ​","ព្រហស្បតិ៍​","សុក្រ​","សៅរ៍"]},kr:{months:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],dayOfWeekShort:["일","월","화","수","목","금","토"],dayOfWeek:["일요일","월요일","화요일","수요일","목요일","금요일","토요일"]},it:{months:["Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre"],dayOfWeekShort:["Dom","Lun","Mar","Mer","Gio","Ven","Sab"],dayOfWeek:["Domenica","Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato"]},da:{months:["Januar","Februar","Marts","April","Maj","Juni","Juli","August","September","Oktober","November","December"],dayOfWeekShort:["Søn","Man","Tir","Ons","Tor","Fre","Lør"],dayOfWeek:["søndag","mandag","tirsdag","onsdag","torsdag","fredag","lørdag"]},no:{months:["Januar","Februar","Mars","April","Mai","Juni","Juli","August","September","Oktober","November","Desember"],dayOfWeekShort:["Søn","Man","Tir","Ons","Tor","Fre","Lør"],dayOfWeek:['Søndag','Mandag','Tirsdag','Onsdag','Torsdag','Fredag','Lørdag']},ja:{months:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dayOfWeekShort:["日","月","火","水","木","金","土"],dayOfWeek:["日曜","月曜","火曜","水曜","木曜","金曜","土曜"]},vi:{months:["Tháng 1","Tháng 2","Tháng 3","Tháng 4","Tháng 5","Tháng 6","Tháng 7","Tháng 8","Tháng 9","Tháng 10","Tháng 11","Tháng 12"],dayOfWeekShort:["CN","T2","T3","T4","T5","T6","T7"],dayOfWeek:["Chủ nhật","Thứ hai","Thứ ba","Thứ tư","Thứ năm","Thứ sáu","Thứ bảy"]},sl:{months:["Januar","Februar","Marec","April","Maj","Junij","Julij","Avgust","September","Oktober","November","December"],dayOfWeekShort:["Ned","Pon","Tor","Sre","Čet","Pet","Sob"],dayOfWeek:["Nedelja","Ponedeljek","Torek","Sreda","Četrtek","Petek","Sobota"]},cs:{months:["Leden","Únor","Březen","Duben","Květen","Červen","Červenec","Srpen","Září","Říjen","Listopad","Prosinec"],dayOfWeekShort:["Ne","Po","Út","St","Čt","Pá","So"]},hu:{months:["Január","Február","Március","Április","Május","Június","Július","Augusztus","Szeptember","Október","November","December"],dayOfWeekShort:["Va","Hé","Ke","Sze","Cs","Pé","Szo"],dayOfWeek:["vasárnap","hétfő","kedd","szerda","csütörtök","péntek","szombat"]},az:{months:["Yanvar","Fevral","Mart","Aprel","May","Iyun","Iyul","Avqust","Sentyabr","Oktyabr","Noyabr","Dekabr"],dayOfWeekShort:["B","Be","Ça","Ç","Ca","C","Ş"],dayOfWeek:["Bazar","Bazar ertəsi","Çərşənbə axşamı","Çərşənbə","Cümə axşamı","Cümə","Şənbə"]},bs:{months:["Januar","Februar","Mart","April","Maj","Jun","Jul","Avgust","Septembar","Oktobar","Novembar","Decembar"],dayOfWeekShort:["Ned","Pon","Uto","Sri","Čet","Pet","Sub"],dayOfWeek:["Nedjelja","Ponedjeljak","Utorak","Srijeda","Četvrtak","Petak","Subota"]},ca:{months:["Gener","Febrer","Març","Abril","Maig","Juny","Juliol","Agost","Setembre","Octubre","Novembre","Desembre"],dayOfWeekShort:["Dg","Dl","Dt","Dc","Dj","Dv","Ds"],dayOfWeek:["Diumenge","Dilluns","Dimarts","Dimecres","Dijous","Divendres","Dissabte"]},'en-GB':{months:["January","February","March","April","May","June","July","August","September","October","November","December"],dayOfWeekShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dayOfWeek:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},et:{months:["Jaanuar","Veebruar","Märts","Aprill","Mai","Juuni","Juuli","August","September","Oktoober","November","Detsember"],dayOfWeekShort:["P","E","T","K","N","R","L"],dayOfWeek:["Pühapäev","Esmaspäev","Teisipäev","Kolmapäev","Neljapäev","Reede","Laupäev"]},eu:{months:["Urtarrila","Otsaila","Martxoa","Apirila","Maiatza","Ekaina","Uztaila","Abuztua","Iraila","Urria","Azaroa","Abendua"],dayOfWeekShort:["Ig.","Al.","Ar.","Az.","Og.","Or.","La."],dayOfWeek:['Igandea','Astelehena','Asteartea','Asteazkena','Osteguna','Ostirala','Larunbata']},fi:{months:["Tammikuu","Helmikuu","Maaliskuu","Huhtikuu","Toukokuu","Kesäkuu","Heinäkuu","Elokuu","Syyskuu","Lokakuu","Marraskuu","Joulukuu"],dayOfWeekShort:["Su","Ma","Ti","Ke","To","Pe","La"],dayOfWeek:["sunnuntai","maanantai","tiistai","keskiviikko","torstai","perjantai","lauantai"]},gl:{months:["Xan","Feb","Maz","Abr","Mai","Xun","Xul","Ago","Set","Out","Nov","Dec"],dayOfWeekShort:["Dom","Lun","Mar","Mer","Xov","Ven","Sab"],dayOfWeek:["Domingo","Luns","Martes","Mércores","Xoves","Venres","Sábado"]},hr:{months:["Siječanj","Veljača","Ožujak","Travanj","Svibanj","Lipanj","Srpanj","Kolovoz","Rujan","Listopad","Studeni","Prosinac"],dayOfWeekShort:["Ned","Pon","Uto","Sri","Čet","Pet","Sub"],dayOfWeek:["Nedjelja","Ponedjeljak","Utorak","Srijeda","Četvrtak","Petak","Subota"]},ko:{months:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],dayOfWeekShort:["일","월","화","수","목","금","토"],dayOfWeek:["일요일","월요일","화요일","수요일","목요일","금요일","토요일"]},lt:{months:["Sausio","Vasario","Kovo","Balandžio","Gegužės","Birželio","Liepos","Rugpjūčio","Rugsėjo","Spalio","Lapkričio","Gruodžio"],dayOfWeekShort:["Sek","Pir","Ant","Tre","Ket","Pen","Šeš"],dayOfWeek:["Sekmadienis","Pirmadienis","Antradienis","Trečiadienis","Ketvirtadienis","Penktadienis","Šeštadienis"]},lv:{months:["Janvāris","Februāris","Marts","Aprīlis ","Maijs","Jūnijs","Jūlijs","Augusts","Septembris","Oktobris","Novembris","Decembris"],dayOfWeekShort:["Sv","Pr","Ot","Tr","Ct","Pk","St"],dayOfWeek:["Svētdiena","Pirmdiena","Otrdiena","Trešdiena","Ceturtdiena","Piektdiena","Sestdiena"]},mk:{months:["јануари","февруари","март","април","мај","јуни","јули","август","септември","октомври","ноември","декември"],dayOfWeekShort:["нед","пон","вто","сре","чет","пет","саб"],dayOfWeek:["Недела","Понеделник","Вторник","Среда","Четврток","Петок","Сабота"]},mn:{months:["1-р сар","2-р сар","3-р сар","4-р сар","5-р сар","6-р сар","7-р сар","8-р сар","9-р сар","10-р сар","11-р сар","12-р сар"],dayOfWeekShort:["Дав","Мяг","Лха","Пүр","Бсн","Бям","Ням"],dayOfWeek:["Даваа","Мягмар","Лхагва","Пүрэв","Баасан","Бямба","Ням"]},'pt-BR':{months:["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],dayOfWeekShort:["Dom","Seg","Ter","Qua","Qui","Sex","Sáb"],dayOfWeek:["Domingo","Segunda","Terça","Quarta","Quinta","Sexta","Sábado"]},sk:{months:["Január","Február","Marec","Apríl","Máj","Jún","Júl","August","September","Október","November","December"],dayOfWeekShort:["Ne","Po","Ut","St","Št","Pi","So"],dayOfWeek:["Nedeľa","Pondelok","Utorok","Streda","Štvrtok","Piatok","Sobota"]},sq:{months:["Janar","Shkurt","Mars","Prill","Maj","Qershor","Korrik","Gusht","Shtator","Tetor","Nëntor","Dhjetor"],dayOfWeekShort:["Die","Hën","Mar","Mër","Enj","Pre","Shtu"],dayOfWeek:["E Diel","E Hënë","E Martē","E Mërkurë","E Enjte","E Premte","E Shtunë"]},'sr-YU':{months:["Januar","Februar","Mart","April","Maj","Jun","Jul","Avgust","Septembar","Oktobar","Novembar","Decembar"],dayOfWeekShort:["Ned","Pon","Uto","Sre","čet","Pet","Sub"],dayOfWeek:["Nedelja","Ponedeljak","Utorak","Sreda","Četvrtak","Petak","Subota"]},sr:{months:["јануар","фебруар","март","април","мај","јун","јул","август","септембар","октобар","новембар","децембар"],dayOfWeekShort:["нед","пон","уто","сре","чет","пет","суб"],dayOfWeek:["Недеља","Понедељак","Уторак","Среда","Четвртак","Петак","Субота"]},sv:{months:["Januari","Februari","Mars","April","Maj","Juni","Juli","Augusti","September","Oktober","November","December"],dayOfWeekShort:["Sön","Mån","Tis","Ons","Tor","Fre","Lör"],dayOfWeek:["Söndag","Måndag","Tisdag","Onsdag","Torsdag","Fredag","Lördag"]},'zh-TW':{months:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],dayOfWeekShort:["日","一","二","三","四","五","六"],dayOfWeek:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"]},zh:{months:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],dayOfWeekShort:["日","一","二","三","四","五","六"],dayOfWeek:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"]},ug:{months:["1-ئاي","2-ئاي","3-ئاي","4-ئاي","5-ئاي","6-ئاي","7-ئاي","8-ئاي","9-ئاي","10-ئاي","11-ئاي","12-ئاي"],dayOfWeek:["يەكشەنبە","دۈشەنبە","سەيشەنبە","چارشەنبە","پەيشەنبە","جۈمە","شەنبە"]},he:{months:['ינואר','פברואר','מרץ','אפריל','מאי','יוני','יולי','אוגוסט','ספטמבר','אוקטובר','נובמבר','דצמבר'],dayOfWeekShort:["א'","ב'","ג'","ד'","ה'","ו'",'שבת'],dayOfWeek:["ראשון","שני","שלישי","רביעי","חמישי","שישי","שבת","ראשון"]},hy:{months:["Հունվար","Փետրվար","Մարտ","Ապրիլ","Մայիս","Հունիս","Հուլիս","Օգոստոս","Սեպտեմբեր","Հոկտեմբեր","Նոյեմբեր","Դեկտեմբեր"],dayOfWeekShort:["Կի","Երկ","Երք","Չոր","Հնգ","Ուրբ","Շբթ"],dayOfWeek:["Կիրակի","Երկուշաբթի","Երեքշաբթի","Չորեքշաբթի","Հինգշաբթի","Ուրբաթ","Շաբաթ"]},kg:{months:['Үчтүн айы','Бирдин айы','Жалган Куран','Чын Куран','Бугу','Кулжа','Теке','Баш Оона','Аяк Оона','Тогуздун айы','Жетинин айы','Бештин айы'],dayOfWeekShort:["Жек","Дүй","Шей","Шар","Бей","Жум","Ише"],dayOfWeek:["Жекшемб","Дүйшөмб","Шейшемб","Шаршемб","Бейшемби","Жума","Ишенб"]},rm:{months:["Schaner","Favrer","Mars","Avrigl","Matg","Zercladur","Fanadur","Avust","Settember","October","November","December"],dayOfWeekShort:["Du","Gli","Ma","Me","Gie","Ve","So"],dayOfWeek:["Dumengia","Glindesdi","Mardi","Mesemna","Gievgia","Venderdi","Sonda"]},ka:{months:['იანვარი','თებერვალი','მარტი','აპრილი','მაისი','ივნისი','ივლისი','აგვისტო','სექტემბერი','ოქტომბერი','ნოემბერი','დეკემბერი'],dayOfWeekShort:["კვ","ორშ","სამშ","ოთხ","ხუთ","პარ","შაბ"],dayOfWeek:["კვირა","ორშაბათი","სამშაბათი","ოთხშაბათი","ხუთშაბათი","პარასკევი","შაბათი"]}},ownerDocument:document,contentWindow:window,value:'',rtl:!1,format:'Y/m/d H:i',formatTime:'H:i',formatDate:'Y/m/d',startDate:!1,step:60,monthChangeSpinner:!0,closeOnDateSelect:!1,closeOnTimeSelect:!0,closeOnWithoutClick:!0,closeOnInputClick:!0,openOnFocus:!0,timepicker:!0,datepicker:!0,weeks:!1,defaultTime:!1,defaultDate:!1,minDate:!1,maxDate:!1,minTime:!1,maxTime:!1,minDateTime:!1,maxDateTime:!1,allowTimes:[],opened:!1,initTime:!0,inline:!1,theme:'',touchMovedThreshold:5,onSelectDate:function(){},onSelectTime:function(){},onChangeMonth:function(){},onGetWeekOfYear:function(){},onChangeYear:function(){},onChangeDateTime:function(){},onShow:function(){},onClose:function(){},onGenerate:function(){},withoutCopyright:!0,inverseButton:!1,hours12:!1,next:'xdsoft_next',prev:'xdsoft_prev',dayOfWeekStart:0,parentID:'body',timeHeightInTimePicker:25,timepickerScrollbar:!0,todayButton:!0,prevButton:!0,nextButton:!0,defaultSelect:!0,scrollMonth:!0,scrollTime:!0,scrollInput:!0,lazyInit:!1,mask:!1,validateOnBlur:!0,allowBlank:!0,yearStart:1950,yearEnd:2050,monthStart:0,monthEnd:11,style:'',id:'',fixed:!1,roundTime:'round',className:'',weekends:[],highlightedDates:[],highlightedPeriods:[],allowDates:[],allowDateRe:null,disabledDates:[],disabledWeekDays:[],yearOffset:0,beforeShowDay:null,enterLikeTab:!0,showApplyButton:!1},b=null,e=null,l='en',d='en',k={meridiem:['AM','PM']},g=function(){var f=c.i18n[d],g={days:f.dayOfWeek,daysShort:f.dayOfWeekShort,months:f.months,monthsShort:a.map(f.months,function(a){return a.substring(0,3)})};typeof DateFormatter=='function'&&(b=e=new DateFormatter({dateSettings:a.extend({},k,g)}))},h={moment:{default_options:{format:'YYYY/MM/DD HH:mm',formatDate:'YYYY/MM/DD',formatTime:'HH:mm'},formatter:{parseDate:function(b,a){if(f(a))return e.parseDate(b,a);var c=moment(b,a);return!!c.isValid()&&c.toDate()},formatDate:function(b,a){return f(a)?e.formatDate(b,a):moment(b).format(a)},formatMask:function(a){return a.replace(/Y{4}/g,'9999').replace(/Y{2}/g,'99').replace(/M{2}/g,'19').replace(/D{2}/g,'39').replace(/H{2}/g,'29').replace(/m{2}/g,'59').replace(/s{2}/g,'59')}}}},i,f;a.datetimepicker={setLocale:function(a){var b=c.i18n[a]?a:l;d!==b&&(d=b,g())},setDateFormatter:function(d){if(typeof d=='string'&&h.hasOwnProperty(d)){var e=h[d];a.extend(c,e.default_options),b=e.formatter}else b=d}},i={RFC_2822:'D, d M Y H:i:s O',ATOM:'Y-m-dTH:i:sP',ISO_8601:'Y-m-dTH:i:sO',RFC_822:'D, d M y H:i:s O',RFC_850:'l, d-M-y H:i:s T',RFC_1036:'D, d M y H:i:s O',RFC_1123:'D, d M Y H:i:s O',RSS:'D, d M Y H:i:s O',W3C:'Y-m-dTH:i:sP'},f=function(a){return Object.values(i).indexOf(a)!==-1},a.extend(a.datetimepicker,i),g(),window.getComputedStyle||(window.getComputedStyle=function(a){return this.el=a,this.getPropertyValue=function(b){var c=/(-([a-z]))/g;return b==='float'&&(b='styleFloat'),c.test(b)&&(b=b.replace(c,function(b,c,a){return a.toUpperCase()})),a.currentStyle[b]||null},this}),Array.prototype.indexOf||(Array.prototype.indexOf=function(c,d){var a,b;for(a=d||0,b=this.length;a<b;a+=1)if(this[a]===c)return a;return-1}),Date.prototype.countDaysInMonth=function(){return new Date(this.getFullYear(),this.getMonth()+1,0).getDate()},a.fn.xdsoftScroller=function(b,c){return this.each(function(){var d=a(this),k=function(a){var b={x:0,y:0},c;return a.type==='touchstart'||a.type==='touchmove'||a.type==='touchend'||a.type==='touchcancel'?(c=a.originalEvent.touches[0]||a.originalEvent.changedTouches[0],b.x=c.clientX,b.y=c.clientY):(a.type==='mousedown'||a.type==='mouseup'||a.type==='mousemove'||a.type==='mouseover'||a.type==='mouseout'||a.type==='mouseenter'||a.type==='mouseleave')&&(b.x=a.clientX,b.y=a.clientY),b},g,f,h,i,e,l=100,j=!1,r=0,n=0,o=0,p=!1,q=0,m=function(){};if(c==='hide'){d.find('.xdsoft_scrollbar').hide();return}a(this).hasClass('xdsoft_scroller_box')||(g=d.children().eq(0),f=d[0].clientHeight,h=g[0].offsetHeight,i=a('<div class="xdsoft_scrollbar"></div>'),e=a('<div class="xdsoft_scroller"></div>'),i.append(e),d.addClass('xdsoft_scroller_box').append(i),m=function(b){var a=k(b).y-r+q;a<0&&(a=0),a+e[0].offsetHeight>o&&(a=o-e[0].offsetHeight),d.trigger('scroll_element.xdsoft_scroller',[l?a/l:0])},e.on('touchstart.xdsoft_scroller mousedown.xdsoft_scroller',function(g){f||d.trigger('resize_scroll.xdsoft_scroller',[c]),r=k(g).y,q=parseInt(e.css('margin-top'),10),o=i[0].offsetHeight,g.type==='mousedown'||g.type==='touchstart'?(b.ownerDocument&&a(b.ownerDocument.body).addClass('xdsoft_noselect'),a([b.ownerDocument.body,b.contentWindow]).on('touchend mouseup.xdsoft_scroller',function c(){a([b.ownerDocument.body,b.contentWindow]).off('touchend mouseup.xdsoft_scroller',c).off('mousemove.xdsoft_scroller',m).removeClass('xdsoft_noselect')}),a(b.ownerDocument.body).on('mousemove.xdsoft_scroller',m)):(p=!0,g.stopPropagation(),g.preventDefault())}).on('touchmove',function(a){p&&(a.preventDefault(),m(a))}).on('touchend touchcancel',function(){p=!1,q=0}),d.on('scroll_element.xdsoft_scroller',function(b,a){f||d.trigger('resize_scroll.xdsoft_scroller',[a,!0]),a=a>1?1:a<0||isNaN(a)?0:a,e.css('margin-top',l*a),setTimeout(function(){g.css('marginTop',-parseInt((g[0].offsetHeight-f)*a,10))},10)}).on('resize_scroll.xdsoft_scroller',function(k,c,j){var a,b;f=d[0].clientHeight,h=g[0].offsetHeight,a=f/h,b=a*i[0].offsetHeight,a>1?e.hide():(e.show(),e.css('height',parseInt(b>10?b:10,10)),l=i[0].offsetHeight-e[0].offsetHeight,j!==!0&&d.trigger('scroll_element.xdsoft_scroller',[c||Math.abs(parseInt(g.css('marginTop'),10))/(h-f)]))}),d.on('mousewheel',function(b){var a=Math.abs(parseInt(g.css('marginTop'),10));return a=a-b.deltaY*20,a<0&&(a=0),d.trigger('scroll_element.xdsoft_scroller',[a/(h-f)]),b.stopPropagation(),!1}),d.on('touchstart',function(a){j=k(a),n=Math.abs(parseInt(g.css('marginTop'),10))}),d.on('touchmove',function(a){if(j){a.preventDefault();var b=k(a);d.trigger('scroll_element.xdsoft_scroller',[(n-(b.y-j.y))/(h-f)])}}),d.on('touchend touchcancel',function(){j=!1,n=0})),d.trigger('resize_scroll.xdsoft_scroller',[c])})},a.fn.datetimepicker=function(f,G){var r=this,q=48,F=57,m=96,l=105,k=17,n=46,o=13,E=27,g=8,D=37,C=38,u=39,v=40,t=9,w=116,x=65,y=67,z=86,A=90,B=89,h=!1,e=a.isPlainObject(f)||!f?a.extend(!0,{},c,f):a.extend(!0,{},c),p=0,i,s,H=function(a){a.on('open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart',function b(){if(a.is(':disabled')||a.data('xdsoft_datetimepicker'))return;clearTimeout(p),p=setTimeout(function(){a.data('xdsoft_datetimepicker')||i(a),a.off('open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart',b).trigger('open.xdsoft')},100)})};return i=function(p){var c=a('<div class="xdsoft_datetimepicker xdsoft_noselect"></div>'),Y=a('<div class="xdsoft_copyright"><a target="_blank" href="http://xdsoft.net/jqplugins/datetimepicker/">xdsoft.net</a></div>'),H=a('<div class="xdsoft_datepicker active"></div>'),s=a('<div class="xdsoft_monthpicker"><button type="button" class="xdsoft_prev"></button><button type="button" class="xdsoft_today_button"></button><div class="xdsoft_label xdsoft_month"><span></span><i></i></div><div class="xdsoft_label xdsoft_year"><span></span><i></i></div><button type="button" class="xdsoft_next"></button></div>'),R=a('<div class="xdsoft_calendar"></div>'),J=a('<div class="xdsoft_timepicker active"><button type="button" class="xdsoft_prev"></button><div class="xdsoft_time_box"></div><button type="button" class="xdsoft_next"></button></div>'),G=J.find('.xdsoft_time_box').eq(0),r=a('<div class="xdsoft_time_variant"></div>'),Q=a('<button type="button" class="xdsoft_save_selected blue-gradient-button">Save Selected</button>'),P=a('<div class="xdsoft_select xdsoft_monthselect"><div></div></div>'),N=a('<div class="xdsoft_select xdsoft_yearselect"><div></div></div>'),M=!1,V,O,L,I,K,S=0,i,T,W;e.id&&c.attr('id',e.id),e.style&&c.attr('style',e.style),e.weeks&&c.addClass('xdsoft_showweeks'),e.rtl&&c.addClass('xdsoft_rtl'),c.addClass('xdsoft_'+e.theme),c.addClass(e.className),s.find('.xdsoft_month span').after(P),s.find('.xdsoft_year span').after(N),s.find('.xdsoft_month,.xdsoft_year').on('touchstart mousedown.xdsoft',function(j){var b=a(this).find('.xdsoft_select').eq(0),f=0,g=0,h=b.is(':visible'),d,c;s.find('.xdsoft_select').hide(),i.currentTime&&(f=i.currentTime[a(this).hasClass('xdsoft_month')?'getMonth':'getFullYear']()),b[h?'hide':'show']();for(d=b.find('div.xdsoft_option'),c=0;c<d.length;c+=1){if(d.eq(c).data('value')===f)break;g+=d[0].offsetHeight}return b.xdsoftScroller(e,g/(b.children()[0].offsetHeight-b[0].clientHeight)),j.stopPropagation(),!1}),W=function(f){var a=f.originalEvent,b=a.touches?a.touches[0]:a,c,d,g;this.touchStartPosition=this.touchStartPosition||b,c=Math.abs(this.touchStartPosition.clientX-b.clientX),d=Math.abs(this.touchStartPosition.clientY-b.clientY),g=Math.sqrt(c*c+d*d),g>e.touchMovedThreshold&&(this.touchMoved=!0)},s.find('.xdsoft_select').xdsoftScroller(e).on('touchstart mousedown.xdsoft',function(a){var b=a.originalEvent;this.touchMoved=!1,this.touchStartPosition=b.touches?b.touches[0]:b,a.stopPropagation(),a.preventDefault()}).on('touchmove','.xdsoft_option',W).on('touchend mousedown.xdsoft','.xdsoft_option',function(){if(!this.touchMoved){(i.currentTime===void 0||i.currentTime===null)&&(i.currentTime=i.now());var b=i.currentTime.getFullYear();i&&i.currentTime&&i.currentTime[a(this).parent().parent().hasClass('xdsoft_monthselect')?'setMonth':'setFullYear'](a(this).data('value')),a(this).parent().parent().hide(),c.trigger('xchange.xdsoft'),e.onChangeMonth&&a.isFunction(e.onChangeMonth)&&e.onChangeMonth.call(c,i.currentTime,c.data('input')),b!==i.currentTime.getFullYear()&&a.isFunction(e.onChangeYear)&&e.onChangeYear.call(c,i.currentTime,c.data('input'))}}),c.getValue=function(){return i.getCurrentTime()},c.setOptions=function(d){var f={};e=a.extend(!0,{},e,d),d.allowTimes&&a.isArray(d.allowTimes)&&d.allowTimes.length&&(e.allowTimes=a.extend(!0,[],d.allowTimes)),d.weekends&&a.isArray(d.weekends)&&d.weekends.length&&(e.weekends=a.extend(!0,[],d.weekends)),d.allowDates&&a.isArray(d.allowDates)&&d.allowDates.length&&(e.allowDates=a.extend(!0,[],d.allowDates)),d.allowDateRe&&Object.prototype.toString.call(d.allowDateRe)==="[object String]"&&(e.allowDateRe=new RegExp(d.allowDateRe)),d.highlightedDates&&a.isArray(d.highlightedDates)&&d.highlightedDates.length&&(a.each(d.highlightedDates,function(k,i){var h=a.map(i.split(','),a.trim),d,c=new j(b.parseDate(h[0],e.formatDate),h[1],h[2]),g=b.formatDate(c.date,e.formatDate);f[g]!==void 0?(d=f[g].desc,d&&d.length&&c.desc&&c.desc.length&&(f[g].desc=d+"\n"+c.desc)):f[g]=c}),e.highlightedDates=a.extend(!0,[],f)),d.highlightedPeriods&&a.isArray(d.highlightedPeriods)&&d.highlightedPeriods.length&&(f=a.extend(!0,[],e.highlightedDates),a.each(d.highlightedPeriods,function(o,d){var c,n,l,h,g,k,m,i;for(a.isArray(d)?(c=d[0],n=d[1],l=d[2],m=d[3]):(i=a.map(d.split(','),a.trim),c=b.parseDate(i[0],e.formatDate),n=b.parseDate(i[1],e.formatDate),l=i[2],m=i[3]);c<=n;)h=new j(c,l,m),g=b.formatDate(c,e.formatDate),c.setDate(c.getDate()+1),f[g]!==void 0?(k=f[g].desc,k&&k.length&&h.desc&&h.desc.length&&(f[g].desc=k+"\n"+h.desc)):f[g]=h}),e.highlightedDates=a.extend(!0,[],f)),d.disabledDates&&a.isArray(d.disabledDates)&&d.disabledDates.length&&(e.disabledDates=a.extend(!0,[],d.disabledDates)),d.disabledWeekDays&&a.isArray(d.disabledWeekDays)&&d.disabledWeekDays.length&&(e.disabledWeekDays=a.extend(!0,[],d.disabledWeekDays)),(e.open||e.opened)&&!e.inline&&p.trigger('open.xdsoft'),e.inline&&(M=!0,c.addClass('xdsoft_inline'),p.after(c).hide()),e.inverseButton&&(e.next='xdsoft_prev',e.prev='xdsoft_next'),e.datepicker?H.addClass('active'):H.removeClass('active'),e.timepicker?J.addClass('active'):J.removeClass('active'),e.value&&(i.setCurrentTime(e.value),p&&p.val&&p.val(i.str)),isNaN(e.dayOfWeekStart)?e.dayOfWeekStart=0:e.dayOfWeekStart=parseInt(e.dayOfWeekStart,10)%7,e.timepickerScrollbar||G.xdsoftScroller(e,'hide'),e.minDate&&/^[\+\-](.*)$/.test(e.minDate)&&(e.minDate=b.formatDate(i.strToDateTime(e.minDate),e.formatDate)),e.maxDate&&/^[\+\-](.*)$/.test(e.maxDate)&&(e.maxDate=b.formatDate(i.strToDateTime(e.maxDate),e.formatDate)),e.minDateTime&&/^\+(.*)$/.test(e.minDateTime)&&(e.minDateTime=i.strToDateTime(e.minDateTime).dateFormat(e.formatDate)),e.maxDateTime&&/^\+(.*)$/.test(e.maxDateTime)&&(e.maxDateTime=i.strToDateTime(e.maxDateTime).dateFormat(e.formatDate)),Q.toggle(e.showApplyButton),s.find('.xdsoft_today_button').css('visibility',e.todayButton?'visible':'hidden'),s.find('.'+e.prev).css('visibility',e.prevButton?'visible':'hidden'),s.find('.'+e.next).css('visibility',e.nextButton?'visible':'hidden'),X(e),e.validateOnBlur&&p.off('blur.xdsoft').on('blur.xdsoft',function(){var g,d,f;e.allowBlank&&(!a.trim(a(this).val()).length||typeof e.mask=="string"&&a.trim(a(this).val())===e.mask.replace(/[0-9]/g,'_'))?(a(this).val(null),c.data('xdsoft_datetime').empty()):(g=b.parseDate(a(this).val(),e.format),g?a(this).val(b.formatDate(g,e.format)):(d=+[a(this).val()[0],a(this).val()[1]].join(''),f=+[a(this).val()[2],a(this).val()[3]].join(''),!e.datepicker&&e.timepicker&&d>=0&&d<24&&f>=0&&f<60?a(this).val([d,f].map(function(a){return a>9?a:'0'+a}).join(':')):a(this).val(b.formatDate(i.now(),e.format))),c.data('xdsoft_datetime').setCurrentTime(a(this).val())),c.trigger('changedatetime.xdsoft'),c.trigger('close.xdsoft')}),e.dayOfWeekStartPrev=e.dayOfWeekStart===0?6:e.dayOfWeekStart-1,c.trigger('xchange.xdsoft').trigger('afterOpen.xdsoft')},c.data('options',e).on('touchstart mousedown.xdsoft',function(a){return a.stopPropagation(),a.preventDefault(),N.hide(),P.hide(),!1}),G.append(r),G.xdsoftScroller(e),c.on('afterOpen.xdsoft',function(){G.xdsoftScroller(e)}),c.append(H).append(J),e.withoutCopyright!==!0&&c.append(Y),H.append(s).append(R).append(Q),a(e.parentID).append(c),V=function(){var d=this;d.now=function(f){var a=new Date,c,b;return!f&&e.defaultDate&&(c=d.strToDateTime(e.defaultDate),a.setFullYear(c.getFullYear()),a.setMonth(c.getMonth()),a.setDate(c.getDate())),a.setFullYear(a.getFullYear()),!f&&e.defaultTime&&(b=d.strtotime(e.defaultTime),a.setHours(b.getHours()),a.setMinutes(b.getMinutes()),a.setSeconds(b.getSeconds()),a.setMilliseconds(b.getMilliseconds())),a},d.isValidDate=function(a){return Object.prototype.toString.call(a)==="[object Date]"&&!isNaN(a.getTime())},d.setCurrentTime=function(a,b){typeof a=='string'?d.currentTime=d.strToDateTime(a):d.isValidDate(a)?d.currentTime=a:!a&&!b&&e.allowBlank&&!e.inline?d.currentTime=null:d.currentTime=d.now(),c.trigger('xchange.xdsoft')},d.empty=function(){d.currentTime=null},d.getCurrentTime=function(){return d.currentTime},d.nextMonth=function(){(d.currentTime===void 0||d.currentTime===null)&&(d.currentTime=d.now());var b=d.currentTime.getMonth()+1,f;return b===12&&(d.currentTime.setFullYear(d.currentTime.getFullYear()+1),b=0),f=d.currentTime.getFullYear(),d.currentTime.setDate(Math.min(new Date(d.currentTime.getFullYear(),b+1,0).getDate(),d.currentTime.getDate())),d.currentTime.setMonth(b),e.onChangeMonth&&a.isFunction(e.onChangeMonth)&&e.onChangeMonth.call(c,i.currentTime,c.data('input')),f!==d.currentTime.getFullYear()&&a.isFunction(e.onChangeYear)&&e.onChangeYear.call(c,i.currentTime,c.data('input')),c.trigger('xchange.xdsoft'),b},d.prevMonth=function(){(d.currentTime===void 0||d.currentTime===null)&&(d.currentTime=d.now());var b=d.currentTime.getMonth()-1;return b===-1&&(d.currentTime.setFullYear(d.currentTime.getFullYear()-1),b=11),d.currentTime.setDate(Math.min(new Date(d.currentTime.getFullYear(),b+1,0).getDate(),d.currentTime.getDate())),d.currentTime.setMonth(b),e.onChangeMonth&&a.isFunction(e.onChangeMonth)&&e.onChangeMonth.call(c,i.currentTime,c.data('input')),c.trigger('xchange.xdsoft'),b},d.getWeekOfYear=function(d){var f,b;if(e.onGetWeekOfYear&&a.isFunction(e.onGetWeekOfYear))if(f=e.onGetWeekOfYear.call(c,d),typeof f!='undefined')return f;return b=new Date(d.getFullYear(),0,1),b.getDay()!==4&&b.setMonth(0,1+(4-b.getDay()+7)%7),Math.ceil(((d-b)/864e5+b.getDay()+1)/7)},d.strToDateTime=function(c){var a=[],g,f;return c&&c instanceof Date&&d.isValidDate(c)?c:(a=/^([+-]{1})(.*)$/.exec(c),a&&(a[2]=b.parseDate(a[2],e.formatDate)),a&&a[2]?(g=a[2].getTime()-a[2].getTimezoneOffset()*6e4,f=new Date(d.now(!0).getTime()+parseInt(a[1]+'1',10)*g)):f=c?b.parseDate(c,e.format):d.now(),d.isValidDate(f)||(f=d.now()),f)},d.strToDate=function(a){if(a&&a instanceof Date&&d.isValidDate(a))return a;var c=a?b.parseDate(a,e.formatDate):d.now(!0);return d.isValidDate(c)||(c=d.now(!0)),c},d.strtotime=function(a){if(a&&a instanceof Date&&d.isValidDate(a))return a;var c=a?b.parseDate(a,e.formatTime):d.now(!0);return d.isValidDate(c)||(c=d.now(!0)),c},d.str=function(){var a=e.format;return e.yearOffset&&(a=a.replace('Y',d.currentTime.getFullYear()+e.yearOffset),a=a.replace('y',String(d.currentTime.getFullYear()+e.yearOffset).substring(2,4))),b.formatDate(d.currentTime,a)},d.currentTime=this.now()},i=new V,Q.on('touchend click',function(a){a.preventDefault(),c.data('changed',!0),i.setCurrentTime(U()),p.val(i.str()),c.trigger('close.xdsoft')}),s.find('.xdsoft_today_button').on('touchend mousedown.xdsoft',function(){c.data('changed',!0),i.setCurrentTime(0,!0),c.trigger('afterOpen.xdsoft')}).on('dblclick.xdsoft',function(){var a=i.getCurrentTime(),b,d;if(a=new Date(a.getFullYear(),a.getMonth(),a.getDate()),b=i.strToDate(e.minDate),b=new Date(b.getFullYear(),b.getMonth(),b.getDate()),a<b)return;if(d=i.strToDate(e.maxDate),d=new Date(d.getFullYear(),d.getMonth(),d.getDate()),a>d)return;p.val(i.str()),p.trigger('change'),c.trigger('close.xdsoft')}),s.find('.xdsoft_prev,.xdsoft_next').on('touchend mousedown.xdsoft',function(){var b=a(this),c=0,d=!1;(function a(f){b.hasClass(e.next)?i.nextMonth():b.hasClass(e.prev)&&i.prevMonth(),e.monthChangeSpinner&&(d||(c=setTimeout(a,f||100)))})(500),a([e.ownerDocument.body,e.contentWindow]).on('touchend mouseup.xdsoft',function b(){clearTimeout(c),d=!0,a([e.ownerDocument.body,e.contentWindow]).off('touchend mouseup.xdsoft',b)})}),J.find('.xdsoft_prev,.xdsoft_next').on('touchend mousedown.xdsoft',function(){var c=a(this),d=0,f=!1,b=110;(function i(j){var g=G[0].clientHeight,h=r[0].offsetHeight,a=Math.abs(parseInt(r.css('marginTop'),10));c.hasClass(e.next)&&h-g-e.timeHeightInTimePicker>=a?r.css('marginTop','-'+(a+e.timeHeightInTimePicker)+'px'):c.hasClass(e.prev)&&a-e.timeHeightInTimePicker>=0&&r.css('marginTop','-'+(a-e.timeHeightInTimePicker)+'px'),G.trigger('scroll_element.xdsoft_scroller',[Math.abs(parseInt(r[0].style.marginTop,10)/(h-g))]),b=b>10?10:b-10,f||(d=setTimeout(i,j||b))})(500),a([e.ownerDocument.body,e.contentWindow]).on('touchend mouseup.xdsoft',function b(){clearTimeout(d),f=!0,a([e.ownerDocument.body,e.contentWindow]).off('touchend mouseup.xdsoft',b)})}),O=0,c.on('xchange.xdsoft',function(g){clearTimeout(O),O=setTimeout(function(){var o,g,h,n,D,t,u,q,m,w,K,A,J,k,H,j,v,B,C,z,E,F,I,O,y,l,x,L,M,G;for((i.currentTime===void 0||i.currentTime===null)&&(i.currentTime=i.now()),o='',g=new Date(i.currentTime.getFullYear(),i.currentTime.getMonth(),1,12,0,0),h=0,D=i.now(),t=!1,u=!1,q=!1,m=!1,j=[],B=!0,C='';g.getDay()!==e.dayOfWeekStart;)g.setDate(g.getDate()-1);o+='<table><thead><tr>',e.weeks&&(o+='<th></th>');for(n=0;n<7;n+=1)o+='<th>'+e.i18n[d].dayOfWeekShort[(n+e.dayOfWeekStart)%7]+'</th>';for(o+='</tr></thead>',o+='<tbody>',e.maxDate!==!1&&(t=i.strToDate(e.maxDate),t=new Date(t.getFullYear(),t.getMonth(),t.getDate(),23,59,59,999)),e.minDate!==!1&&(u=i.strToDate(e.minDate),u=new Date(u.getFullYear(),u.getMonth(),u.getDate())),e.minDateTime!==!1&&(q=i.strToDate(e.minDateTime),q=new Date(q.getFullYear(),q.getMonth(),q.getDate(),q.getHours(),q.getMinutes(),q.getSeconds())),e.maxDateTime!==!1&&(m=i.strToDate(e.maxDateTime),m=new Date(m.getFullYear(),m.getMonth(),m.getDate(),m.getHours(),m.getMinutes(),m.getSeconds())),m!==!1&&(I=(m.getFullYear()*12+m.getMonth())*31+m.getDate());h<i.currentTime.countDaysInMonth()||g.getDay()!==e.dayOfWeekStart||i.currentTime.getMonth()===g.getMonth();)j=[],h+=1,K=g.getDay(),A=g.getDate(),J=g.getFullYear(),k=g.getMonth(),H=i.getWeekOfYear(g),F='',j.push('xdsoft_date'),e.beforeShowDay&&a.isFunction(e.beforeShowDay.call)?v=e.beforeShowDay.call(c,g):v=null,e.allowDateRe&&Object.prototype.toString.call(e.allowDateRe)==="[object RegExp]"&&(e.allowDateRe.test(b.formatDate(g,e.formatDate))||j.push('xdsoft_disabled')),e.allowDates&&e.allowDates.length>0&&e.allowDates.indexOf(b.formatDate(g,e.formatDate))===-1&&j.push('xdsoft_disabled'),O=(g.getFullYear()*12+g.getMonth())*31+g.getDate(),(t!==!1&&g>t||q!==!1&&g<q||u!==!1&&g<u||m!==!1&&O>I||v&&v[0]===!1)&&j.push('xdsoft_disabled'),e.disabledDates.indexOf(b.formatDate(g,e.formatDate))!==-1&&j.push('xdsoft_disabled'),e.disabledWeekDays.indexOf(K)!==-1&&j.push('xdsoft_disabled'),p.is('[disabled]')&&j.push('xdsoft_disabled'),v&&v[1]!==""&&j.push(v[1]),i.currentTime.getMonth()!==k&&j.push('xdsoft_other_month'),(e.defaultSelect||c.data('changed'))&&b.formatDate(i.currentTime,e.formatDate)===b.formatDate(g,e.formatDate)&&j.push('xdsoft_current'),b.formatDate(D,e.formatDate)===b.formatDate(g,e.formatDate)&&j.push('xdsoft_today'),(g.getDay()===0||g.getDay()===6||e.weekends.indexOf(b.formatDate(g,e.formatDate))!==-1)&&j.push('xdsoft_weekend'),e.highlightedDates[b.formatDate(g,e.formatDate)]!==void 0&&(w=e.highlightedDates[b.formatDate(g,e.formatDate)],j.push(w.style===void 0?'xdsoft_highlighted_default':w.style),F=w.desc===void 0?'':w.desc),e.beforeShowDay&&a.isFunction(e.beforeShowDay)&&j.push(e.beforeShowDay(g)),B&&(o+='<tr>',B=!1,e.weeks&&(o+='<th>'+H+'</th>')),o+='<td data-date="'+A+'" data-month="'+k+'" data-year="'+J+'"'+' class="xdsoft_date xdsoft_day_of_week'+g.getDay()+' '+j.join(' ')+'" title="'+F+'">'+'<div>'+A+'</div>'+'</td>',g.getDay()===e.dayOfWeekStartPrev&&(o+='</tr>',B=!0),g.setDate(A+1);if(o+='</tbody></table>',R.html(o),s.find('.xdsoft_label span').eq(0).text(e.i18n[d].months[i.currentTime.getMonth()]),s.find('.xdsoft_label span').eq(1).text(i.currentTime.getFullYear()+e.yearOffset),C='',z='',k='',y=0,e.minTime!==!1&&(l=i.strtotime(e.minTime),y=60*l.getHours()+l.getMinutes()),x=24*60,e.maxTime!==!1&&(l=i.strtotime(e.maxTime),x=60*l.getHours()+l.getMinutes()),e.minDateTime!==!1&&(l=i.strToDateTime(e.minDateTime),L=b.formatDate(i.currentTime,e.formatDate)===b.formatDate(l,e.formatDate),L&&(k=60*l.getHours()+l.getMinutes(),k>y&&(y=k))),e.maxDateTime!==!1&&(l=i.strToDateTime(e.maxDateTime),M=b.formatDate(i.currentTime,e.formatDate)===b.formatDate(l,e.formatDate),M&&(k=60*l.getHours()+l.getMinutes(),k<x&&(x=k))),E=function(d,f){var g=i.now(),h,l=e.allowTimes&&a.isArray(e.allowTimes)&&e.allowTimes.length,k;g.setHours(d),d=parseInt(g.getHours(),10),g.setMinutes(f),f=parseInt(g.getMinutes(),10),j=[],k=60*d+f,(p.is('[disabled]')||k>=x||k<y)&&j.push('xdsoft_disabled'),h=new Date(i.currentTime),h.setHours(parseInt(i.currentTime.getHours(),10)),l||h.setMinutes(Math[e.roundTime](i.currentTime.getMinutes()/e.step)*e.step),(e.initTime||e.defaultSelect||c.data('changed'))&&h.getHours()===parseInt(d,10)&&(!l&&e.step>59||h.getMinutes()===parseInt(f,10))&&(e.defaultSelect||c.data('changed')?j.push('xdsoft_current'):e.initTime&&j.push('xdsoft_init_time')),parseInt(D.getHours(),10)===parseInt(d,10)&&parseInt(D.getMinutes(),10)===parseInt(f,10)&&j.push('xdsoft_today'),C+='<div class="xdsoft_time '+j.join(' ')+'" data-hour="'+d+'" data-minute="'+f+'">'+b.formatDate(g,e.formatTime)+'</div>'},!e.allowTimes||!a.isArray(e.allowTimes)||!e.allowTimes.length)for(h=0,n=0;h<(e.hours12?12:24);h+=1)for(n=0;n<60;n+=e.step){if(G=h*60+n,G<y)continue;if(G>=x)continue;z=(h<10?'0':'')+h,k=(n<10?'0':'')+n,E(z,k)}else for(h=0;h<e.allowTimes.length;h+=1)z=i.strtotime(e.allowTimes[h]).getHours(),k=i.strtotime(e.allowTimes[h]).getMinutes(),E(z,k);r.html(C),f='';for(h=parseInt(e.yearStart,10);h<=parseInt(e.yearEnd,10);h+=1)f+='<div class="xdsoft_option '+(i.currentTime.getFullYear()===h?'xdsoft_current':'')+'" data-value="'+h+'">'+(h+e.yearOffset)+'</div>';N.children().eq(0).html(f);for(h=parseInt(e.monthStart,10),f='';h<=parseInt(e.monthEnd,10);h+=1)f+='<div class="xdsoft_option '+(i.currentTime.getMonth()===h?'xdsoft_current':'')+'" data-value="'+h+'">'+e.i18n[d].months[h]+'</div>';P.children().eq(0).html(f),a(c).trigger('generate.xdsoft')},10),g.stopPropagation()}).on('afterOpen.xdsoft',function(){if(e.timepicker){var a,b,c,d;r.find('.xdsoft_current').length?a='.xdsoft_current':r.find('.xdsoft_init_time').length&&(a='.xdsoft_init_time'),a?(b=G[0].clientHeight,c=r[0].offsetHeight,d=r.find(a).index()*e.timeHeightInTimePicker+1,c-b<d&&(d=c-b),G.trigger('scroll_element.xdsoft_scroller',[parseInt(d,10)/(c-b)])):G.trigger('scroll_element.xdsoft_scroller',[0])}}),L=0,R.on('touchend click.xdsoft','td',function(f){f.stopPropagation(),L+=1;var d=a(this),b=i.currentTime;if((b===void 0||b===null)&&(i.currentTime=i.now(),b=i.currentTime),d.hasClass('xdsoft_disabled'))return!1;b.setDate(1),b.setFullYear(d.data('year')),b.setMonth(d.data('month')),b.setDate(d.data('date')),c.trigger('select.xdsoft',[b]),p.val(i.str()),e.onSelectDate&&a.isFunction(e.onSelectDate)&&e.onSelectDate.call(c,i.currentTime,c.data('input'),f),c.data('changed',!0),c.trigger('xchange.xdsoft'),c.trigger('changedatetime.xdsoft'),(L>1||e.closeOnDateSelect===!0||e.closeOnDateSelect===!1&&!e.timepicker)&&!e.inline&&c.trigger('close.xdsoft'),setTimeout(function(){L=0},200)}),r.on('touchstart','div',function(a){this.touchMoved=!1}).on('touchmove','div',W).on('touchend click.xdsoft','div',function(f){if(!this.touchMoved){f.stopPropagation();var d=a(this),b=i.currentTime;if((b===void 0||b===null)&&(i.currentTime=i.now(),b=i.currentTime),d.hasClass('xdsoft_disabled'))return!1;b.setHours(d.data('hour')),b.setMinutes(d.data('minute')),c.trigger('select.xdsoft',[b]),c.data('input').val(i.str()),e.onSelectTime&&a.isFunction(e.onSelectTime)&&e.onSelectTime.call(c,i.currentTime,c.data('input'),f),c.data('changed',!0),c.trigger('xchange.xdsoft'),c.trigger('changedatetime.xdsoft'),e.inline!==!0&&e.closeOnTimeSelect===!0&&c.trigger('close.xdsoft')}}),H.on('mousewheel.xdsoft',function(a){return!e.scrollMonth||(a.deltaY<0?i.nextMonth():i.prevMonth(),!1)}),p.on('mousewheel.xdsoft',function(a){if(!e.scrollInput)return!0;if(!e.datepicker&&e.timepicker)return I=r.find('.xdsoft_current').length?r.find('.xdsoft_current').eq(0).index():0,I+a.deltaY>=0&&I+a.deltaY<r.children().length&&(I+=a.deltaY),r.children().eq(I).length&&r.children().eq(I).trigger('mousedown'),!1;if(e.datepicker&&!e.timepicker)return H.trigger(a,[a.deltaY,a.deltaX,a.deltaY]),p.val&&p.val(i.str()),c.trigger('changedatetime.xdsoft'),!1}),c.on('changedatetime.xdsoft',function(d){if(e.onChangeDateTime&&a.isFunction(e.onChangeDateTime)){var b=c.data('input');e.onChangeDateTime.call(c,i.currentTime,b,d),delete e.value,b.trigger('change')}}).on('generate.xdsoft',function(){e.onGenerate&&a.isFunction(e.onGenerate)&&e.onGenerate.call(c,i.currentTime,c.data('input')),M&&(c.trigger('afterOpen.xdsoft'),M=!1)}).on('click.xdsoft',function(a){a.stopPropagation()}),I=0,T=function(a,b){do if(a=a.parentNode,!a||b(a)===!1)break;while(a.nodeName!=='HTML')},K=function(){var j=c.data('input'),f=j.offset(),g=j[0],n='top',b=f.top+g.offsetHeight-1,d=f.left,l="absolute",i=a(e.contentWindow).width(),k=a(e.contentWindow).height(),h=a(e.contentWindow).scrollTop(),o,m,p,q;e.ownerDocument.documentElement.clientWidth-f.left<H.parent().outerWidth(!0)&&(q=H.parent().outerWidth(!0)-g.offsetWidth,d=d-q),j.parent().css('direction')==='rtl'&&(d-=c.outerWidth()-j.outerWidth()),e.fixed?(b-=h,d-=a(e.contentWindow).scrollLeft(),l="fixed"):(m=!1,T(g,function(a){if(a===null)return!1;if(e.contentWindow.getComputedStyle(a).getPropertyValue('position')==='fixed')return m=!0,!1}),m?(l='fixed',b+c.outerHeight()>k+h?(n='bottom',b=k+h-f.top):b-=h):b+c[0].offsetHeight>k+h&&(b=f.top-c[0].offsetHeight+1),b<0&&(b=0),d+g.offsetWidth>i&&(d=i-g.offsetWidth)),p=c[0],T(p,function(a){var b;if(b=e.contentWindow.getComputedStyle(a).getPropertyValue('position'),b==='relative'&&i>=a.offsetWidth)return d=d-(i-a.offsetWidth)/2,!1}),o={position:l,left:d,top:'',bottom:''},o[n]=b,c.css(o)},c.on('open.xdsoft',function(d){var b=!0;e.onShow&&a.isFunction(e.onShow)&&(b=e.onShow.call(c,i.currentTime,c.data('input'),d)),b!==!1&&(c.show(),K(),a(e.contentWindow).off('resize.xdsoft',K).on('resize.xdsoft',K),e.closeOnWithoutClick&&a([e.ownerDocument.body,e.contentWindow]).on('touchstart mousedown.xdsoft',function b(){c.trigger('close.xdsoft'),a([e.ownerDocument.body,e.contentWindow]).off('touchstart mousedown.xdsoft',b)}))}).on('close.xdsoft',function(b){var d=!0;s.find('.xdsoft_month,.xdsoft_year').find('.xdsoft_select').hide(),e.onClose&&a.isFunction(e.onClose)&&(d=e.onClose.call(c,i.currentTime,c.data('input'),b)),d!==!1&&!e.opened&&!e.inline&&c.hide(),b.stopPropagation()}).on('toggle.xdsoft',function(){c.is(':visible')?c.trigger('close.xdsoft'):c.trigger('open.xdsoft')}).data('input',p),S=0,c.data('xdsoft_datetime',i),c.setOptions(e);function U(){var a=!1,b;return e.startDate?a=i.strToDate(e.startDate):(a=e.value||(p&&p.val&&p.val()?p.val():''),a?(a=i.strToDateTime(a),e.yearOffset&&(a=new Date(a.getFullYear()-e.yearOffset,a.getMonth(),a.getDate(),a.getHours(),a.getMinutes(),a.getSeconds(),a.getMilliseconds()))):e.defaultDate&&(a=i.strToDateTime(e.defaultDate),e.defaultTime&&(b=i.strtotime(e.defaultTime),a.setHours(b.getHours()),a.setMinutes(b.getMinutes())))),a&&i.isValidDate(a)?c.data('changed',!0):a='',a||0}function X(c){var d=function(a,b){var c=a.replace(/([\[\]\/\{\}\(\)\-\.\+]{1})/g,'\\$1').replace(/_/g,'{digit+}').replace(/([0-9]{1})/g,'{digit$1}').replace(/\{digit([0-9]{1})\}/g,'[0-$1_]{1}').replace(/\{digit[\+]\}/g,'[0-9_]{1}');return new RegExp(c).test(b)},f=function(a){try{if(c.ownerDocument.selection&&c.ownerDocument.selection.createRange){var b=c.ownerDocument.selection.createRange();return b.getBookmark().charCodeAt(2)-2}if(a.setSelectionRange)return a.selectionStart}catch(a){return 0}},e=function(a,b){if(a=typeof a=="string"||a instanceof String?c.ownerDocument.getElementById(a):a,!a)return!1;if(a.createTextRange){var d=a.createTextRange();return d.collapse(!0),d.moveEnd('character',b),d.moveStart('character',b),d.select(),!0}return!!a.setSelectionRange&&(a.setSelectionRange(b,b),!0)};c.mask&&p.off('keydown.xdsoft'),c.mask===!0&&(b.formatMask?c.mask=b.formatMask(c.format):c.mask=c.format.replace(/Y/g,'9999').replace(/F/g,'9999').replace(/m/g,'19').replace(/d/g,'39').replace(/H/g,'29').replace(/i/g,'59').replace(/s/g,'59')),a.type(c.mask)==='string'&&(d(c.mask,p.val())||(p.val(c.mask.replace(/[0-9]/g,'_')),e(p[0],0)),p.on('paste.xdsoft',function(g){var i=g.clipboardData||g.originalEvent.clipboardData||window.clipboardData,h=i.getData('text'),b=this.value,f=this.selectionStart,j=b.substr(0,f),k=b.substr(f+h.length);return b=j+h+k,f+=h.length,d(c.mask,b)?(this.value=b,e(this,f)):a.trim(b)===''?this.value=c.mask.replace(/[0-9]/g,'_'):p.trigger('error_input.xdsoft'),g.preventDefault(),!1}),p.on('keydown.xdsoft',function(j){var i=this.value,f=j.which,b=this.selectionStart,G=this.selectionEnd,r=b!==G,s,O,N,L,K,J,M,I,H,P,Q,R,S,T,U,V,W;if(f>=q&&f<=F||f>=m&&f<=l||f===g||f===n){for(s=f===g||f===n?'_':String.fromCharCode(m<=f&&f<=l?f-q:f),f===g&&b&&!r&&(b-=1);!0;){if(O=c.mask.substr(b,1),N=b<c.mask.length,L=b>0,K=/[^0-9_]/,J=K.test(O),M=J&&N&&L,!M)break;b+=f===g&&!r?-1:1}if(r?(I=G-b,H=c.mask.replace(/[0-9]/g,'_'),P=H.substr(b,I),Q=P.substr(1),R=i.substr(0,b),S=s+Q,T=i.substr(b+I),i=R+S+T):(U=i.substr(0,b),V=s,W=i.substr(b+1),i=U+V+W),a.trim(i)==='')i=H;else if(b===c.mask.length)return j.preventDefault(),!1;for(b+=f===g?0:1;/[^0-9_]/.test(c.mask.substr(b,1))&&b<c.mask.length&&b>0;)b+=f===g?0:1;d(c.mask,i)?(this.value=i,e(this,b)):a.trim(i)===''?this.value=c.mask.replace(/[0-9]/g,'_'):p.trigger('error_input.xdsoft')}else if([x,y,z,A,B].indexOf(f)!==-1&&h||[E,C,v,D,u,w,k,t,o].indexOf(f)!==-1)return!0;return j.preventDefault(),!1}))}i.setCurrentTime(U()),p.data('xdsoft_datetimepicker',c).on('open.xdsoft focusin.xdsoft mousedown.xdsoft touchstart',function(){if(p.is(':disabled')||p.data('xdsoft_datetimepicker').is(':visible')&&e.closeOnInputClick)return;if(!e.openOnFocus)return;clearTimeout(S),S=setTimeout(function(){if(p.is(':disabled'))return;M=!0,i.setCurrentTime(U(),!0),e.mask&&X(e),c.trigger('open.xdsoft')},100)}).on('keydown.xdsoft',function(f){var b,d=f.which;if([o].indexOf(d)!==-1&&e.enterLikeTab)return b=a("input:visible,textarea:visible,button:visible,a:visible"),c.trigger('close.xdsoft'),b.eq(b.index(this)+1).focus(),!1;if([t].indexOf(d)!==-1)return c.trigger('close.xdsoft'),!0}).on('blur.xdsoft',function(){c.trigger('close.xdsoft')})},s=function(b){var c=b.data('xdsoft_datetimepicker');c&&(c.data('xdsoft_datetime',null),c.remove(),b.data('xdsoft_datetimepicker',null).off('.xdsoft'),a(e.contentWindow).off('resize.xdsoft'),a([e.contentWindow,e.ownerDocument.body]).off('mousedown.xdsoft touchstart'),b.unmousewheel&&b.unmousewheel())},a(e.ownerDocument).off('keydown.xdsoftctrl keyup.xdsoftctrl').on('keydown.xdsoftctrl',function(a){a.keyCode===k&&(h=!0)}).on('keyup.xdsoftctrl',function(a){a.keyCode===k&&(h=!1)}),this.each(function(){var c=a(this).data('xdsoft_datetimepicker'),d;if(c){if(a.type(f)==='string')switch(f){case'show':a(this).select().focus(),c.trigger('open.xdsoft');break;case'hide':c.trigger('close.xdsoft');break;case'toggle':c.trigger('toggle.xdsoft');break;case'destroy':s(a(this));break;case'reset':this.value=this.defaultValue,(!this.value||!c.data('xdsoft_datetime').isValidDate(b.parseDate(this.value,e.format)))&&c.data('changed',!1),c.data('xdsoft_datetime').setCurrentTime(this.value);break;case'validate':d=c.data('input'),d.trigger('blur.xdsoft');break;default:c[f]&&a.isFunction(c[f])&&(r=c[f](G))}else c.setOptions(f);return 0}a.type(f)!=='string'&&(!e.lazyInit||e.open||e.inline?i(a(this)):H(a(this)))}),r},a.fn.datetimepicker.defaults=c;function j(a,b,c){"use strict";this.date=a,this.desc=b,this.style=c}};(function(a){typeof define=='function'&&define.amd?define(['jquery','jquery-mousewheel'],a):typeof exports=='object'?module.exports=a(require('jquery')):a(jQuery)})(datetimepickerFactory),function(a){typeof define=='function'&&define.amd?define(['jquery'],a):typeof exports=='object'?module.exports=a:a(jQuery)}(function(a){var h=['wheel','mousewheel','DOMMouseScroll','MozMousePixelScroll'],d='onwheel'in document||document.documentMode>=9?['wheel']:['mousewheel','DomMouseScroll','MozMousePixelScroll'],j=Array.prototype.slice,e,b,g,c;if(a.event.fixHooks)for(g=h.length;g;)a.event.fixHooks[h[--g]]=a.event.mouseHooks;c=a.event.special.mousewheel={version:'3.1.12',setup:function(){if(this.addEventListener)for(var b=d.length;b;)this.addEventListener(d[--b],f,!1);else this.onmousewheel=f;a.data(this,'mousewheel-line-height',c.getLineHeight(this)),a.data(this,'mousewheel-page-height',c.getPageHeight(this))},teardown:function(){if(this.removeEventListener)for(var b=d.length;b;)this.removeEventListener(d[--b],f,!1);else this.onmousewheel=null;a.removeData(this,'mousewheel-line-height'),a.removeData(this,'mousewheel-page-height')},getLineHeight:function(d){var c=a(d),b=c['offsetParent'in a.fn?'offsetParent':'parent']();return b.length||(b=a('body')),parseInt(b.css('fontSize'),10)||parseInt(c.css('fontSize'),10)||16},getPageHeight:function(b){return a(b).height()},settings:{adjustOldDeltas:!0,normalizeOffset:!0}},a.fn.extend({mousewheel:function(a){return a?this.bind('mousewheel',a):this.trigger('mousewheel')},unmousewheel:function(a){return this.unbind('mousewheel',a)}});function f(h){var d=h||window.event,p=j.call(arguments,1),l=0,g=0,f=0,m=0,q=0,r=0,n,o,s;if(h=a.event.fix(d),h.type='mousewheel','detail'in d&&(f=d.detail*-1),'wheelDelta'in d&&(f=d.wheelDelta),'wheelDeltaY'in d&&(f=d.wheelDeltaY),'wheelDeltaX'in d&&(g=d.wheelDeltaX*-1),'axis'in d&&d.axis===d.HORIZONTAL_AXIS&&(g=f*-1,f=0),l=f===0?g:f,'deltaY'in d&&(f=d.deltaY*-1,l=f),'deltaX'in d&&(g=d.deltaX,f===0&&(l=g*-1)),f===0&&g===0)return;return d.deltaMode===1?(n=a.data(this,'mousewheel-line-height'),l*=n,f*=n,g*=n):d.deltaMode===2&&(o=a.data(this,'mousewheel-page-height'),l*=o,f*=o,g*=o),m=Math.max(Math.abs(f),Math.abs(g)),(!b||m<b)&&(b=m,i(d,m)&&(b/=40)),i(d,m)&&(l/=40,g/=40,f/=40),l=Math[l>=1?'floor':'ceil'](l/b),g=Math[g>=1?'floor':'ceil'](g/b),f=Math[f>=1?'floor':'ceil'](f/b),c.settings.normalizeOffset&&this.getBoundingClientRect&&(s=this.getBoundingClientRect(),q=h.clientX-s.left,r=h.clientY-s.top),h.deltaX=g,h.deltaY=f,h.deltaFactor=b,h.offsetX=q,h.offsetY=r,h.deltaMode=0,p.unshift(h,l,g,f),e&&clearTimeout(e),e=setTimeout(k,200),(a.event.dispatch||a.event.handle).apply(this,p)}function k(){b=null}function i(a,b){return c.settings.adjustOldDeltas&&a.type==='mousewheel'&&b%120===0}})